;***********************************************************************
;                            stroka.lsp  v.1.3                         *
;                               & stroka.dcl                           *
;               Copyright by Sash ( )                  *
;                             AutoCAD r.15                          *
;                           03  2002                            *
;                     E-Mail: kosap@yanex.ru                           *
;***********************************************************************
;    stroka.lsp 
; :           1.  7  . 
; 2.   s=4*  ,     .
; 3.     .
; 4.     -   .
; 5.          -
;         2  -  20 :)
; 6.       -   .
;       shrift,     gosta_w.shx.
;      v1.1.
; 7.          .
;       .   .
; 8. v1.2.    .    
;    Dim           
; 9.  ,  . 
;10.     . v.1.3.
;
;***********************************************************************
;                            stroka.lsp                                *
;                                 & stroka.dcl                         *
;               Copyright by PG (Genchik Pospelov)                     *
;                             AutoCAD r.14-15                       *
;                           17. 1999                              *
;                   E-Mail: gepos@mail.ru                              *
;***********************************************************************

;;;-------------> HELP <------------------------------------------------
(defun ab_prog (ab_progr /)
 
 (if (not (new_dialog "ab_text" DCL_ID)) (exit))
 (start_list "ab_progr")
 (mapcar 'add_list ab_progr)
 (end_list)

 (action_tile  "accept" "(done_dialog)")
 (start_dialog)
)

;;;-------------> WORKING FUNCTION <------------------------------------
(defun w_str ( n stxt sz_t / a_txt p_txt pt1 pt2 pt3 sze)

  (cond ((or (= n 1) (= n 2)) (setq a_txt stxt))
        ((or (= n 3) (= n 4)) (setq a_txt (strcat "S=" stxt "*")))
  )
  (print n)
  (setq pt1 (getpoint "\n   ")
	pt2 (getpoint pt1 "\n   ")
;;;	pt3 (getpoint pt2 "\n  ")
 	sze (*(strlen a_txt) sz_t 0.7)
  )
(if (= strelka 0)  (command "_.DONUT" 0 1 pt1 ""))
  (if (>= (car pt2)(car pt1))
    (setq pt3 (list (+(car pt2) sze 2.0)(cadr pt2))
	  p_txt(list (+(car pt2) 1.8)(+(cadr pt2) 1.5))
    )
  )
  (if (< (car pt3)(car pt2)) 
    (setq pt3 (list (-(car pt2) sze 2.0)(cadr pt2))
	  p_txt(list (+(car pt3) 1.8)(+(cadr pt2) 1.0))
    )
  )
  (if (or(= n 1)(= n 3)) (COMMAND "_.PLINE" pt1 pt2 pt3 (command))
  )
  (if (or(= n 2)(= n 4)) (progn
			  (setq sze (polar pt1 (angle pt1 pt2) 3.0))
	(COMMAND "_.PLINE" pt1 "w" 0.0 1.5 sze "w" 0.0 0.0 pt2 pt3 (command))
			   )
  )
  (COMMAND "_.TEXT" p_txt sz_t 0 a_txt)
)
;;;-------------> MAIN FUNCTION <---------------------------------------
(defun c:stroka2(/  $value	s1txt		s2txt
		   a_sel        sz_txt          help_pr
		   info_pr      old_snap        strelka
		   shrift )

 (setq old_snap  (getvar "osmode")
       clar      (getvar "CLAYER")
       oscor     (getvar "OSNAPCOORD")
       SshNeedLay "Dim"		;   Dim    
 )

 (if(null(tblsearch "LAYER" SshNeedLay))(command"_LAYER" "_N" SshNeedLay "")) 
  
;;; (setvar "osmode"   0)
 (setvar "blipmode" 0)
 (setvar "cmdecho"  0)
 (setvar "CLAYER" SshNeedLay)
 (setvar "OSNAPCOORD" 1)  

 (setq help_pr (list
		 " -     - " " "
		 "    .  stroka" " "	 
		 "     ,"
                 "      "
		 "  . "  " "
               )
      info_pr (list
		 " -     - "
		 "    .  stroka"
		 " "
		 "      "
                 "     .  "
		 "        "
		 " . "   "  "
		 "  -   \"\"    "
                 " 03  2002."
                 "          Copyright  \"Sash Ltd\" "
                 "                             mailto:kosap@rambler.ru "
                )
  )
  
 ;; open window functions 
 (setq DCL_ID (load_dialog "stroka.dcl"))
 (if (not (new_dialog "stxt" dcl_id)) (exit))
 ;; Set up some defaults.
 (setq s1txt "1"
       s2txt "3"
     strelka "0"
     sz_txt (rtos 7 2 2)
     a_sel 1
     shrift '("7" "1.8" "2.5" "3.5" "5" "10" "14" "20" "28" "40")
     nachalo '("" "" "" "") 
 )
 (set_tile "s1txt" s1txt)
 (set_tile "s2txt" s2txt)
 (set_tile "sz_txt" sz_txt)
 (set_tile "on_s1txt" "1")
 (set_tile "on_s2txt" "0")

 (start_list "szpop_txt")
  (mapcar 'add_list shrift)
 (end_list) 
  
 (mode_tile "s1txt" 2)
 (mode_tile "s2txt" 1)
 (start_list "strelka")
  (mapcar 'add_list nachalo)
 (end_list) 
    
   
 (action_tile "s1txt"    "(setq s1txt  $value)")
 (action_tile "s2txt"    "(setq s2txt  $value)")
 (action_tile "szpop_txt"   "(setq sz_txt (nth (atoi $value) shrift))")
 (action_tile "strelka"   "(setq strelka (nth (atoi $value) nachalo))")
  

 (action_tile "on_s1txt"
   "(progn (mode_tile \"s1txt\" 0)(mode_tile \"s1txt\" 2)
                   (mode_tile \"s2txt\" 1)(setq a_sel 1))")
 (action_tile "on_s2txt"
   "(progn (mode_tile \"s2txt\" 0)(mode_tile \"s2txt\" 2)
                   (mode_tile \"s1txt\" 1)(setq a_sel 3))") 
   
 (action_tile "accept" "(done_dialog 1)")
 (action_tile "cancel" "(done_dialog 0)")
 (action_tile "help" "(ab_prog help_pr)")
 (action_tile "info" "(ab_prog info_pr)")
 (setq what_next (start_dialog)
          sz_txt (atof sz_txt)
 )
 (cond ((= strelka "0") (setq strelka 0))
       ((= strelka "") (setq strelka 1))
       ((= strelka "") (setq strelka 2))
       ((= strelka "") (setq strelka 2)) 
 ) ;;;;end cond

 (setq  a_sel (+ a_sel strelka)
 )
   
 ;       "Ok" -  
 (if (= 1 what_next)
              (cond ((<= a_sel 2)(w_str a_sel s1txt sz_txt ))
		    ((> a_sel 2) (w_str a_sel s2txt sz_txt ))
	      )    
 ) 
 (unload_dialog dcl_id)  ;; unload

 (setvar "blipmode" 1)   ;; end-return operation
 (setvar  "cmdecho" 1)
;;; (setvar   "osmode" old_snap)
 (setvar "CLAYER" clar)
 (setvar "OSNAPCOORD" oscor)    
 

 (princ)
)
;;;---------> THE  END <------------------------------------------
